//
//  LightCodedOutput.m
//  EyesBot
//
//  Created by John Keogh on 12/9/12.
//  Copyright (c) 2013 Upsoni. Released under CC-BY

#import "LightCodedOutput.h"
#import "LightCellOutput.h"


@implementation LightCodedOutput

const int kFlashDuration=100;//could probably have a separate dark duration, but using this plus toggle now


@synthesize lightTimer;
@synthesize rightPower, leftPower, counter;
@synthesize leftLight, rightLight;

+ (id)sharedInstance
{
    static dispatch_once_t pred = 0;
    __strong static id _sharedObject = nil;
    dispatch_once(&pred, ^{
        _sharedObject = [[self alloc] init];
    });
    return _sharedObject;
}

-(void)startLights{
    if(self.lightTimer==nil){
        self.lightTimer = [NSTimer scheduledTimerWithTimeInterval:0.1 target:self selector:@selector(updateLights) userInfo:nil repeats:YES];
    }
    self.counter=0;
}


-(void)stopLights{
    self.leftLight.on = NO;
    [self.leftLight performSelectorOnMainThread:@selector(setNeedsDisplay) withObject:nil waitUntilDone:NO];
    self.rightLight.on = NO;
    [self.rightLight performSelectorOnMainThread:@selector(setNeedsDisplay) withObject:nil waitUntilDone:NO];
    [self.lightTimer invalidate];
    self.lightTimer = nil;
}

-(void)updateLights{
    if(self.counter>=10){
        counter=0;
    }
    
    BOOL rightForwardOn = NO;
    BOOL leftForwardOn = NO;
    
    //poor man's PWM
    if(counter==0){//1,2,5,7
        if((self.leftPower==1)||(self.leftPower==2)||(self.leftPower==5)||(self.leftPower==7)){
            leftForwardOn= YES;
        }
        if((self.rightPower==1)||(self.rightPower==2)||(self.rightPower==5)||(self.rightPower==7)){
            rightForwardOn= YES;
        }
    }
    else if(counter==1){//4,6,7,8,9
        if((self.leftPower==4)||(self.leftPower==6)||(self.leftPower==7)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==4)||(self.rightPower==6)||(self.rightPower==7)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==2){//4,5,6,7,8,9
        if((self.leftPower==4)||(self.leftPower==5)||(self.leftPower==6)||(self.leftPower==7)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==4)||(self.rightPower==5)||(self.rightPower==6)||(self.rightPower==7)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==3){//3,8,9
        if((self.leftPower==3)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==3)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==4){//2,5,6,7,8,9
        if((self.leftPower==2)||(self.leftPower==5)||(self.leftPower==6)||(self.leftPower==7)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==2)||(self.rightPower==5)||(self.rightPower==6)||(self.rightPower==7)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==5){//7,9
        if((self.leftPower==7)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==7)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==6){//3,4,5,6,8,9
        if((self.leftPower==3)||(self.leftPower==4)||(self.leftPower==5)||(self.leftPower==6)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==3)||(self.rightPower==4)||(self.rightPower==5)||(self.rightPower==6)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==7){//4,7,8,9
        if((self.leftPower==4)||(self.leftPower==7)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==4)||(self.rightPower==7)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==8){//5,6,7,8,9
        if((self.leftPower==5)||(self.leftPower==6)||(self.leftPower==7)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==5)||(self.rightPower==6)||(self.rightPower==7)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    else if(counter==9){//3,6,8,9
        if((self.leftPower==3)||(self.leftPower==6)||(self.leftPower==8)||(self.leftPower==9)){
            leftForwardOn= YES;
        }
        if((self.rightPower==3)||(self.rightPower==6)||(self.rightPower==8)||(self.rightPower==9)){
            rightForwardOn= YES;
        }
    }
    
    if(self.leftPower==10){
        leftForwardOn= YES;
    }
    if(self.rightPower==10){
        rightForwardOn= YES;
    }
    
    if(!self.leftLight.on&&leftForwardOn){
        self.leftLight.on = YES;
        [self.leftLight performSelectorOnMainThread:@selector(setNeedsDisplay) withObject:nil waitUntilDone:NO];
    }
    else if(self.leftLight.on&&!leftForwardOn){
        self.leftLight.on = NO;
        [self.leftLight performSelectorOnMainThread:@selector(setNeedsDisplay) withObject:nil waitUntilDone:NO];
    }
    
    if(!self.rightLight.on&&rightForwardOn){
        self.rightLight.on = YES;
        [self.rightLight performSelectorOnMainThread:@selector(setNeedsDisplay) withObject:nil waitUntilDone:NO];
    }
    else if(self.rightLight.on&&!rightForwardOn){
        self.rightLight.on = NO;
        [self.rightLight performSelectorOnMainThread:@selector(setNeedsDisplay) withObject:nil waitUntilDone:NO];
    }
    
    self.counter++;
}


@end
