//
//  SteeringViewController.m
//  Steering
//
//  Created by John Keogh on 4/23/13.
//  Copyright (c) 2013 Upsoni. Released under CC-BY
//

#import "SteeringViewController.h"
#import "LightCodedOutput.h"
#import "LightCellOutput.h"

@interface SteeringViewController ()

@end

@implementation SteeringViewController

@synthesize steeringSlider, leftSpeedLabel, rightSpeedLabel, startStopButton;
@synthesize leftLight, rightLight;
@synthesize started;

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.leftSpeedLabel.text = @"100%";
    self.rightSpeedLabel.text = @"100%";
    
    //add all the uiimagecontrollers
    CGRect screenRect = [[UIScreen mainScreen] bounds];
    CGFloat screenHeight = screenRect.size.height;
    CGRect rect;
    CGPoint rectOrigin;
    rectOrigin.x=20;
    rectOrigin.y=screenHeight-80;
    CGSize rectSize;
    rectSize.width=50;
    rectSize.height=50;
    rect.size = rectSize;
    rect.origin = rectOrigin;
    self.leftLight = [[LightCellOutput alloc] initWithFrame:rect];
    [[self view] addSubview:self.leftLight];
    [self.leftLight setOn:NO];
    rectOrigin.x=screenRect.size.width-70;
    rect.origin = rectOrigin;
    self.rightLight = [[LightCellOutput alloc] initWithFrame:rect];
    [[self view] addSubview:self.rightLight];
    [self.rightLight setOn:NO];
    
    [[LightCodedOutput sharedInstance] setLeftLight:self.leftLight];
    [[LightCodedOutput sharedInstance] setRightLight:self.rightLight];
    [[LightCodedOutput sharedInstance] setLeftPower:10];
    [[LightCodedOutput sharedInstance] setRightPower:10];
}


- (IBAction) sliderValueChanged:(id)sender{
    float steeringValue = self.steeringSlider.value;
    float rightValue=10;
    float leftValue=10;
    if(steeringValue==0.5){
        self.leftSpeedLabel.text = @"100%";
        self.rightSpeedLabel.text = @"100%";
    }
    else if(steeringValue<0.5){
        self.leftSpeedLabel.text = [NSString stringWithFormat:@"%i%%", (int)((steeringValue*2)*100)];
        self.rightSpeedLabel.text = @"100%";
        leftValue = (int)(int)((steeringValue*2)*10);
    }
    else{
        self.leftSpeedLabel.text = @"100%";
        self.rightSpeedLabel.text = [NSString stringWithFormat:@"%i%%", (int)((1.0-(steeringValue-0.5)*2)*100)];
        rightValue = (int)(int)((1.0-(steeringValue-0.5)*2)*10);
    }
    
    [[LightCodedOutput sharedInstance] setLeftPower:leftValue];
    [[LightCodedOutput sharedInstance] setRightPower:rightValue];
}

-(IBAction) startButtonToggled:(id)sender{

    self.started = !self.started;
    
    if(self.started){
        [self.startStopButton  setTitle:@"Stop" forState:UIControlStateNormal];
        [[LightCodedOutput sharedInstance] startLights];
        [[LightCodedOutput sharedInstance]updateLights];
    }
    else{
        [self.startStopButton  setTitle:@"Start" forState:UIControlStateNormal];
        [self.steeringSlider setValue:0.5];
        self.leftSpeedLabel.text = @"100%";
        self.rightSpeedLabel.text = @"100%";
        
        [[LightCodedOutput sharedInstance] setLeftPower:10];
        [[LightCodedOutput sharedInstance] setRightPower:10];
        [[LightCodedOutput sharedInstance] stopLights];
    }
    
    
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
